#include "modlist.h"
#include "../inout/test_inout.h"

static int
input_hooks(test_input_hooks_t** hooks) {
  hooks[0] = &test_input_int_modlist;
  hooks[1] = &test_input_int_modlist;
  return 2;
}

static int
output_hooks(test_output_hooks_t** hooks) {
  hooks[0] = &test_output_int_modlist;
  return 1;
}

static intptr_t isle (void* v1, void* v2) {
  return ((intptr_t) v1) <= ((intptr_t) v2);
}

static void
run(modref_t** inputs,
    modref_t** outputs)
{
  scope();
  merge(read(inputs[0]),
        read(inputs[1]),
        isle, outputs[0]);
}

static test_app_hooks_t hooks = {
  input_hooks,
  output_hooks,
  test_input_sizes_for_2_equally_sized_inputs,
  run,
  verif(run),
};

test_app_t test_app_merge = {"merge", &hooks};
